git.lirion.de

Of git, get, and gud

aboutsummaryrefslogtreecommitdiffstats
path: root/.bash_profile
blob: 126f88048382ec80a3cb892840ea393bb7eec501 (plain)
1
2
3
4
5
6
7
8
9
10
11
# .bash_profile

# Set umask to something world-unreadable in any case
umask 027

# Get the aliases and functions
if [ -f ~/.bashrc ]; then
	. ~/.bashrc
fi

# User specific environment and startup programs
ight .gs { font-weight: bold } /* Generic.Strong */ .highlight .gu { color: #800080; font-weight: bold } /* Generic.Subheading */ .highlight .gt { color: #aa0000 } /* Generic.Traceback */ .highlight .kc { color: #0000aa } /* Keyword.Constant */ .highlight .kd { color: #0000aa } /* Keyword.Declaration */ .highlight .kn { color: #0000aa } /* Keyword.Namespace */ .highlight .kp { color: #0000aa } /* Keyword.Pseudo */ .highlight .kr { color: #0000aa } /* Keyword.Reserved */ .highlight .kt { color: #00aaaa } /* Keyword.Type */ .highlight .m { color: #009999 } /* Literal.Number */ .highlight .s { color: #aa5500 } /* Literal.String */ .highlight .na { color: #1e90ff } /* Name.Attribute */ .highlight .nb { color: #00aaaa } /* Name.Builtin */ .highlight .nc { color: #00aa00; text-decoration: underline } /* Name.Class */ .highlight .no { color: #aa0000 } /* Name.Constant */ .highlight .nd { color: #888888 } /* Name.Decorator */ .highlight .ni { color: #880000; font-weight: bold } /* Name.Entity */ .highlight .nf { color: #00aa00 } /* Name.Function */ .highlight .nn { color: #00aaaa; text-decoration: underline } /* Name.Namespace */ .highlight .nt { color: #1e90ff; font-weight: bold } /* Name.Tag */ .highlight .nv { color: #aa0000 } /* Name.Variable */ .highlight .ow { color: #0000aa } /* Operator.Word */ .highlight .w { color: #bbbbbb } /* Text.Whitespace */ .highlight .mb { color: #009999 } /* Literal.Number.Bin */ .highlight .mf { color: #009999 } /* Literal.Number.Float */ .highlight .mh { color: #009999 } /* Literal.Number.Hex */ .highlight .mi { color: #009999 } /* Literal.Number.Integer */ .highlight .mo { color: #009999 } /* Literal.Number.Oct */ .highlight .sa { color: #aa5500 } /* Literal.String.Affix */ .highlight .sb { color: #aa5500 } /* Literal.String.Backtick */ .highlight .sc { color: #aa5500 } /* Literal.String.Char */ .highlight .dl { color: #aa5500 } /* Literal.String.Delimiter */ .highlight .sd { color: #aa5500 } /* Literal.String.Doc */ .highlight .s2 { color: #aa5500 } /* Literal.String.Double */ .highlight .se { color: #aa5500 } /* Literal.String.Escape */ .highlight .sh { color: #aa5500 } /* Literal.String.Heredoc */ .highlight .si { color: #aa5500 } /* Literal.String.Interpol */ .highlight .sx { color: #aa5500 } /* Literal.String.Other */ .highlight .sr { color: #009999 } /* Literal.String.Regex */ .highlight .s1 { color: #aa5500 } /* Literal.String.Single */ .highlight .ss { color: #0000aa } /* Literal.String.Symbol */ .highlight .bp { color: #00aaaa } /* Name.Builtin.Pseudo */ .highlight .fm { color: #00aa00 } /* Name.Function.Magic */ .highlight .vc { color: #aa0000 } /* Name.Variable.Class */ .highlight .vg { color: #aa0000 } /* Name.Variable.Global */ .highlight .vi { color: #aa0000 } /* Name.Variable.Instance */ .highlight .vm { color: #aa0000 } /* Name.Variable.Magic */ .highlight .il { color: #009999 } /* Literal.Number.Integer.Long */
#!/bin/bash

# Copyright 2009 Peter Palfrader
#
# Permission is hereby granted, free of charge, to any person obtaining
# a copy of this software and associated documentation files (the
# "Software"), to deal in the Software without restriction, including
# without limitation the rights to use, copy, modify, merge, publish,
# distribute, sublicense, and/or sell copies of the Software, and to
# permit persons to whom the Software is furnished to do so, subject to
# the following conditions:
#
# The above copyright notice and this permission notice shall be
# included in all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
# EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
# NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
# LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
# OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
# WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

UPDATE_RUNS=3
STATUSDIR=/var/cache/dsa/nagios
STATUS="${STATUSDIR}"/apt
SLEEP_MAX=$(( 15 * 60 ))
MAX_AGE=$(( 23 * 60 * 60 ))

# we want to run if any of the following things is true
#  - we have never run before
#  - var/lib/dpkg/status has been touched since the last run
#  - var/cache/apt/pkgcache.bin has been touched since the last run
#  - our last run ended with 'apt-get update failed'
#  - our last run has been more than MAX_AGE (23hrs) ago
run_required() {
	local run=0
	local norun=1

	[ -e "$STATUS" ] || return $run
	[ /var/lib/dpkg/status -nt "$STATUS" ] && return $run
	[ /var/cache/apt/pkgcache.bin -nt "$STATUS" ] && return $run
	grep "apt-get update failed" "$STATUS" > /dev/null && return $run

	local last_mod
	last_mod=`stat -c "%Y" "$STATUS"`
	now=`date +%s`
	age=$(( $now - $last_mod ))
	[ "$age" -gt "$MAX_AGE" ] && return $run

	return $norun
}

mkdir -p "${STATUSDIR}"

# do stuff only when required, or when asked to
if [ "${1:-""}" != "-f" ] ; then
	run_required || exit 0
fi

# sleep if called non-interactively
if [ -z "$TERM" -o "$TERM" = "dumb" ]; then
	sleep $(( $RANDOM % $SLEEP_MAX ))
fi

# run apt-get update, retry a few times if it fails
count=0
while [ "$count" -lt "$UPDATE_RUNS" ]; do
	flock -e /var/lib/apt/lists apt-get update -qq >/dev/null >&2
	if [ "$?" = "0" ]; then break; fi
	sleep $(( $RANDOM % 600 ))
	count="$(( $count + 1 ))"
done
if [ "$count" -ge "$UPDATE_RUNS" ]; then
	(echo "WARNING"
	 echo "apt-get update failed") > "$STATUS"
	 exit 1
fi

# run the apt check itself
tmp=`tempfile`
trap "rm -f '$tmp'" exit
#/usr/share/dsa/apt-status-check --noupdate --timeout=600 > "$tmp"
/usr/lib/nagios/plugins/dsa-check-packages > "$tmp"
result="$?"
case "$result" in
  0)
	st="OK"
	;;
  1)
	st="WARNING"
	;;
  2)
	st="CRITICAL"
	;;
  *)
	st="UNKNOWN"
	;;
esac
(echo "$st"; cat "$tmp") > "$STATUS"